
.486 					
.model flat, stdcall 	
option casemap: none 	

include windows.inc
include user32.inc
include kernel32.inc
include comctl32.inc
include mapi32.inc
include wsock32.inc
include ws2_32.inc

;include ws2bth.inc

includelib user32.lib
includelib kernel32.lib
includelib ComCtl32.Lib
includelib MAPI32.Lib
includelib wsock32.lib
includelib ws2_32.lib

; --- user defined libraries
include Error-Lib.asm

DlgProc PROTO :DWORD,:DWORD,:DWORD,:DWORD ; --- main dialog procedure

_SockStartup proto :DWORD ; --- startup socket service
_SocketConnect proto :DWORD ; --- connect to defined port
_openFile proto :DWORD

WSAQUERYSET struct
	dwSize 							DWORD  ?
	lpszServiceInstanceName 		DWORD  ?
	lpServiceClassId				DWORD  ?
	lpVersion						DWORD  ?
	lpszComment						DWORD  ?
	dwNameSpace						DWORD  ?
	lpNSProviderId					DWORD  ?
	lpszContext						DWORD  ?
	dwNumberOfProtocols				DWORD  ?  
	lpafpProtocols					DWORD  ?
	lpszQueryString					DWORD  ?
	dwNumberOfCsAddrs				DWORD  ?
	lpcsaBuffer						DWORD  ?
	dwOutputFlags					DWORD  ?
	lpBlob							DWORD ?
WSAQUERYSET EndS

.const
	
	IDD_MAIN equ 1001
	
	BUFFER_SIZE equ 30
	RNRSERVICE_REGISTER equ 0
.data
	
	SVCID_BTH_PROVIDER textequ <{06aa63e0h , 07d60h , 041ffh , {0afh , 0b2h , 03eh , 0e6h , 0d2h , 0d9h , 039h , 02dh}}>
	
	szAppName db 'Kotton',0
	szSocError db 'Socket Error',0
	bPass BOOL FALSE
	
	szTestString1 db 'ATI0',0
	
	wsaData WSADATA <>
	sin sockaddr_in <>
	
	tempBuffer db BUFFER_SIZE dup(0)
	tempBuffer1 db BUFFER_SIZE dup(0)
	tempBuffer2 db BUFFER_SIZE dup(0)
	
	szComOut db 'COM5',0
	szComIn db 'COM6',0
	
	szStatus db 'Status: %s',0
	
	version DWORD 2,2
	
.data?

	hInstance dd ?
	hDlg dd ?	
	hSockOut dd ?
	hSockIn dd ?
	
	bytesRead DWORD ?
	comProp COMMPROP <?>
	comConfig COMMCONFIG <?> 
	comTime COMMTIMEOUTS <?>
	dcb DCB <?>
	
	hLookUp dd ?
	
.code

start:

	invoke GetModuleHandle,NULL
	mov hInstance, eax
	invoke DialogBoxParam,hInstance,IDD_MAIN,0,addr DlgProc,0
	invoke ExitProcess,eax

DlgProc	proc hWin:DWORD,uMsg:DWORD,wParam:DWORD,lParam:DWORD
	
	local icc:INITCOMMONCONTROLSEX
	
	.if uMsg == WM_INITDIALOG
		
		mov icc.dwICC, ICC_LISTVIEW_CLASSES or ICC_TREEVIEW_CLASSES or ICC_STANDARD_CLASSES		
		mov icc.dwSize, sizeof icc		
		
		invoke InitCommonControlsEx,addr icc
		
		mov eax, hWin
		mov hDlg, eax
		
		mov bPass, FALSE
	
	.elseif uMsg == WM_COMMAND
		mov eax, wParam
		.if ax == 1002 ; --- connect
			invoke _SockStartup,hWin
		.endif
	.elseif uMsg == WM_CLOSE
		.if bPass == TRUE
			invoke WSACleanup
		.endif	
		invoke EndDialog,hWin,0
	.else
		mov eax, FALSE
		ret	
	.endif

	mov eax, TRUE
	Ret
DlgProc EndP

_openFile proc h:DWORD
	
	mov comTime.ReadIntervalTimeout,20
	mov comTime.ReadTotalTimeoutConstant,100
	mov comTime.ReadTotalTimeoutMultiplier,10
	mov comTime.WriteTotalTimeoutConstant,100
	mov comTime.WriteTotalTimeoutMultiplier,10
	
	invoke SetDlgItemText,h,1003,NULL
	invoke GetDlgItemText,h,1005,addr tempBuffer,30
	
	invoke CreateFile,addr tempBuffer,GENERIC_READ or GENERIC_WRITE,0,0,OPEN_EXISTING,NULL,0
	.if eax == INVALID_HANDLE_VALUE
		invoke ErrMsg,h,9000d,0d,addr szSocError
		xor eax,eax
		ret
	.else
		mov hSockOut, eax	
	.endif
	
	invoke SetCommTimeouts,hSockOut,addr comTime
	.if eax == 0
		invoke ErrMsg,h,6600d,0d,addr szSocError
		invoke CloseHandle,hSockOut
		xor eax,eax
		ret
	.endif
	
	invoke GetCommState,hSockOut,addr dcb
	.if eax == 0
		invoke ErrMsg,h,7100d,0d,addr szSocError
		invoke CloseHandle,hSockOut
		xor eax,eax
		ret
	.endif
	
	mov dcb.DCBlength, sizeof dcb
	mov dcb.BaudRate, 19200d
	mov dcb.StopBits,ONESTOPBIT
	mov dcb.Parity,EVENPARITY
	mov dcb.ByteSize,8
	;mov dcb.EofChar,013h
	
	invoke SetCommState,hSockOut, addr dcb
	.if eax == 0
		invoke ErrMsg,h,7100d,0d,addr szSocError
		invoke CloseHandle,hSockOut
		xor eax,eax
		ret
	.endif
	
	invoke GetCommState,hSockOut,addr dcb
	.if eax == 0
		invoke ErrMsg,h,7100d,0d,addr szSocError
		invoke CloseHandle,hSockOut
		xor eax,eax
		ret
	.else
		;mov eax,dcb.BaudRate
		;invoke wsprintf,addr tempBuffer,addr szBaudRate,eax
		;invoke SetDlgItemText,h,1003,addr tempBuffer
	.endif
		
	invoke WriteFile,hSockOut,addr szTestString1,32,addr bytesRead,NULL
	.if eax == 0
		invoke ErrMsg,h,8200d,0d,addr szSocError
	.else
		; write was successful
	.endif
	
	;invoke Sleep,6000
	
	mov byte ptr ds:[bytesRead],0
	mov byte ptr ds:[tempBuffer],0
	mov byte ptr ds:[tempBuffer1],0
	
	mov bPass, TRUE
	
	mov bytesRead, 0
		
	.while bPass == TRUE
		invoke ReadFile,hSockOut,addr tempBuffer2,32,addr bytesRead,NULL
		.if eax == 0
			invoke ErrMsg,h,7200d,0d,addr szSocError
			mov bPass, FALSE
			.break
		.else
			mov eax,bytesRead
			.if eax != 0
				invoke wsprintf,addr tempBuffer1,addr szStatus,addr tempBuffer2
				invoke SetDlgItemText,h,1003,addr tempBuffer2
				mov bPass, FALSE
				.break
			.else
				; read until there is data...
			.endif
		.endif
	.endw
	
	invoke CloseHandle,hSockOut
	invoke CloseHandle,hSockIn
	
	xor eax, eax
	Ret
_openFile EndP

_SockStartup proc h:DWORD
	
	local wsaRegInfo:WSAQUERYSET
	;local csaddr:CSADDR_INFO
	;local sockBTH:SOCKADDR
	
	mov ax,0002h
	
	invoke WSAStartup,eax,addr wsaData
	.if eax != 0
		invoke ErrMsg,h,4500,1d,addr szSocError
		xor eax, eax
		ret
	.endif
	
	; register the NS_BTH namespace
	
	;invoke getsockname,
	
	;mov csaddr.
	
;	mov wsaRegInfo.dwSize, SizeOf wsaRegInfo
;	lea eax, offset SVCID_BTH_PROVIDER
;	mov wsaRegInfo.lpServiceClassId, eax
;	mov wsaRegInfo.dwNameSpace, NS_BTH
;	mov wsaRegInfo.dwNumberOfCsAddrs,1
;	mov wsaRegInfo.lpcsaBuffer, addr csaddr
;	
;	invoke WSASetService,addr wsaRegInfo,RNRSERVICE_REGISTER,0 
	
	invoke _SocketConnect, h
	
	xor eax, eax
	Ret
_SockStartup EndP

_SocketConnect proc h:DWORD
	
	local wsaq:WSAQUERYSET
	
	invoke RtlZeroMemory,addr wsaq,SizeOf wsaq
	
	mov wsaq.dwSize, SizeOf wsaq
	mov wsaq.dwNameSpace, 16
	mov wsaq.lpcsaBuffer, NULL
	
	invoke WSALookupServiceBegin,addr wsaq,LUP_CONTAINERS,addr hLookUp
	.if eax != ERROR_SUCCESS
		invoke ErrMsg,h,4600,1,addr szSocError
		;xor eax, eax
		;ret
	.endif
	
	invoke WSALookupServiceEnd,hLookUp
	
	invoke WSACleanup
	
	xor eax, eax
	Ret
_SocketConnect EndP


end start